package com.herou.lib;

import com.herou.lib.utils.DataUtils;
import com.herou.lib.utils.HttpUtils;
import com.herou.lib.utils.SignUtils;
import org.apache.commons.codec.binary.Base64;
import org.apache.commons.lang3.StringUtils;
import org.json.JSONObject;

import java.net.URLDecoder;
import java.util.HashMap;
import java.util.Map;

/**
 * 类描述：　[usdk_server_demo]<br/>
 * 项目名称：[usdk_server_demo]<br/>
 * 包名：　　[com.herou.com.herou.lib.utils]<br/>
 * 创建人：　[杨挺]<br/>
 * 创建时间：[2021/7/19 下午4:40]<br/>
 */
public class USDK
{
	/** 登录校验的服务器地址 */
//	public enum LoginUrlEnum
//	{
//		CN("https://usdk.ultrasdk.com/hu/v1/login/checkUserInfo.lg"), //适用于国内服务器校验地址
//		GLOBAL("https://uglobal.ultrasdk.com/hu/v1/login/checkUserInfo.lg"); //适用于海外服务器校验地址
//
//		String url;
//
//		LoginUrlEnum(String url)
//		{
//			this.url = url;
//		}
//	}

	/** 游戏在SDK平台的应用码 */
	private final String productId;
	/** 游戏的APP_KEY */
	private final String productKey;
	/** SDK服务端为游戏的同步的秘钥 */
	private final String callbackKey;
	private final String checkUserUrl;

	public USDK(String productId, String productKey, String callbackKey, LoginUrlEnum checkUserUrl)
	{
		this.productId = productId;
		this.productKey = productKey;
		this.callbackKey = callbackKey;
//		this.checkUserUrl = checkUserUrl.url;
		this.checkUserUrl = "https://uglobal.ultrasdk.com/hu/v1/login/checkUserInfo.lg";//适用于海外服务器校验地址
	}

	/**
	 * 模拟登录校验
	 * @param cUid 客户端登录成功后的渠道uid
	 * @param accessToken 客户端登录成功后的accessToken
	 */
	public JSONObject login(String cUid, String cName, String accessToken)
	{
		String data = DataUtils.markData("cUid", cUid, "'cName'", cName, "accessToken", accessToken);

		long timestamp = System.currentTimeMillis() / 1000;
		String pcode = productId;
		String sign = SignUtils.markSign(productKey, "pcode", pcode, "data", data, "timestamp", timestamp + "");

		Map<String, String> nvps = new HashMap<String, String>();
		nvps.put("pcode", pcode);
		nvps.put("data", data);
		nvps.put("timestamp", String.valueOf(timestamp));
		nvps.put("sign", sign);
		try
		{
			return new JSONObject(HttpUtils.post(checkUserUrl, nvps));
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
		return null;
	}

	public JSONObject payCallback(String dataStr, String signStr)
	{
		if (dataStr.contains("%"))
			dataStr = URLDecoder.decode(dataStr); // url解码，根据实际的项目框架来，看是否需要url解码
		if (signStr.contains("%"))
			signStr = URLDecoder.decode(signStr); // url解码，根据实际的项目框架来，看是否需要url解码

		String dataSign = SignUtils.markSign(callbackKey, "data", dataStr);
		if (!StringUtils.equals(dataSign, signStr))
		{
			return null;
		}
		String data = new String(Base64.decodeBase64(dataStr.getBytes()));
		return new JSONObject(data);
	}
}
