package com.herou.lib.utils;

import org.apache.commons.codec.binary.Base64;
import org.json.JSONObject;

import java.util.HashMap;
import java.util.Map;

/**
 * 类描述：　[DataUtils工具类，用作解析生成data]<br/>
 * 项目名称：[herou]<br/>
 * 包名：　　[com.herou.utils]<br/>
 * 创建人：　[杨挺]<br/>
 * 创建时间：[2017/8/9 15:13]<br/>
 */
public class DataUtils
{
	private static final String CHAR_CODE = "UTF-8";

	public static String revertData(String str)
	{
		try
		{
			String finalData;
			if (str.length() > 51)
			{
				char[] chars = changeArray(str.toCharArray(), 1, 33, 10, 42, 18, 50, 19, 51);
				finalData = new String(chars);
			}
			else
			{
				finalData = str;
			}
			byte[] buffer = Base64.decodeBase64(finalData);
			String result;
			result = new String(buffer);
			return result;
		}
		catch (Exception e)
		{
			e.printStackTrace();
			return "";
		}
	}

	/** 计算Data */
	public static String markData(Object... key_val)
	{
		try
		{
			return _markData(key_val);
		}
		catch (Exception e)
		{
			return "";
		}
	}

	/** 计算Data */
	private static String _markData(Object... key_val) throws Exception
	{
		Map<String, Object> map = new HashMap<String, Object>();
		for (int i = 1; i < key_val.length; i += 2)
			if (key_val[i] != null && key_val[i - 1] != null)
				map.put(key_val[i - 1] + "", key_val[i]);
		return markDataFlag(map);
	}

	/** 具体执行计算Data */
	public static String markDataFlag(Map<String, Object> params) throws Exception
	{
//		List<String> keys = new ArrayList<String>(params.keySet());

		JSONObject nameValuePairs = new JSONObject();
		//按参数的 KEY 进行排序 (升序 )
//		Collections.sort(keys);

		for (Map.Entry<String, Object> entry : params.entrySet())
		{
			String key = entry.getKey();
			if (key == null)
			{
				throw new NullPointerException("key == null");
			}
			nameValuePairs.put(key, entry.getValue());
		}
		//将数组转化为 json 字符串
		String jsonStr = nameValuePairs.toString();

		// 对 jsonStrbase64 进行  编码
		String tmpData = Base64.encodeBase64String(jsonStr.getBytes(CHAR_CODE));

		// 将 tmpData 进行对称换位 ,  得到结果就是 data 密文数据
		String finalData;
		if (tmpData.length() > 51)
		{
			char[] chars = changeArray(tmpData.toCharArray(), 1, 33, 10, 42, 18, 50, 19, 51);
			finalData = new String(chars);
		}
		else
		{
			finalData = tmpData;
		}
		return finalData;
	}

	/** 换位 */
	public static char[] changeArray(char[] chars, int... index)
	{
		for (int i = 1; i < index.length; i += 2)
		{
			final int l = index[i - 1];
			final int r = index[i];
			char c = chars[l];
			chars[l] = chars[r];
			chars[r] = c;
		}
		return chars;
	}

}
