package com.herou.lib.utils;

import org.apache.commons.lang3.StringUtils;
import org.apache.http.Header;
import org.apache.http.HttpEntity;
import org.apache.http.NameValuePair;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.*;
import org.apache.http.conn.ssl.SSLConnectionSocketFactory;
import org.apache.http.conn.ssl.X509HostnameVerifier;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.message.BasicHeader;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.protocol.HTTP;
import org.apache.http.util.EntityUtils;
import org.json.JSONObject;

import javax.net.ssl.*;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.security.KeyManagementException;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.security.SecureRandom;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;
import java.util.*;

/**
 * 类描述：　[HttpUtils]<br/>
 * 项目名称：[herou]<br/>
 * 包名：　　[com.herou.utils]<br/>
 * 创建人：　[杨挺]<br/>
 * 创建时间：[2017/8/23 11:26]<br/>
 */
public class HttpUtils
{

	private final static int DEFAULT_TIMEOUT = 10;

	/**
	 * 忽视证书HostName
	 */
	private static final X509HostnameVerifier ignoreHostnameVerifier = new X509HostnameVerifier()
	{
		public boolean verify(String s, SSLSession sslsession)
		{
			//log.warn(" WARNING: Hostname is not matched for cert. ");
			return true;
		}

		@Override
		public void verify(String host, SSLSocket ssl)
		{

		}

		@Override
		public void verify(String host, X509Certificate cert) throws SSLException
		{

		}

		@Override
		public void verify(String host, String[] cns, String[] subjectAlts) throws SSLException
		{
		}
	};
	/**
	 * Ignore Certification
	 */
	private static final TrustManager ignoreCertificationTrustManger = new X509TrustManager()
	{
		@Override
		public X509Certificate[] getAcceptedIssuers()
		{
			return null;
		}

		@Override
		public void checkServerTrusted(X509Certificate[] arg0, String arg1) throws CertificateException
		{
		}

		@Override
		public void checkClientTrusted(X509Certificate[] arg0, String arg1) throws CertificateException
		{
		}
	};

	/**
	 * 去掉url中的路径，留下请求参数部分
	 * @param strURL url地址
	 * @return url请求参数部分
	 */
	private static String truncateUrlPage(String strURL)
	{
		String strAllParam = null;
		String[] arrSplit = null;

		strURL = strURL.trim();

		arrSplit = strURL.split("[?]");
		if (strURL.length() > 1)
		{
			if (arrSplit.length > 1)
			{
				if (arrSplit[1] != null)
				{
					strAllParam = arrSplit[1];
				}
			}
			else
			{
				if (arrSplit.length == 1)
				{
					strAllParam = arrSplit[0];
				}
			}
		}

		return strAllParam;
	}

	/**
	 * 解析出url参数中的键值对
	 * 如 "index.jsp?Action=del&id=123"，解析出Action:del,id:123存入map中
	 * @param URL url地址
	 * @return url请求参数部分
	 */
	public static Map<String, String> truncateUrlParam(String URL)
	{
		Map<String, String> mapRequest = new HashMap<String, String>();

		String[] arrSplit = null;

		String strUrlParam = truncateUrlPage(URL);
		if (strUrlParam == null)
		{
			return mapRequest;
		}
		//每个键值为一组 www.2cto.com
		arrSplit = strUrlParam.split("[&]");
		for (String strSplit : arrSplit)
		{
			String[] arrSplitEqual = null;
			arrSplitEqual = strSplit.split("[=]");

			//解析出键值
			if (arrSplitEqual.length > 1)
			{
				//正确解析
				mapRequest.put(arrSplitEqual[0], URLDecoder.decode(arrSplitEqual[1]));

			}
			else
			{
				if (!("".equals(arrSplitEqual[0])))
				{
					//只有参数没有值，不加入
					mapRequest.put(arrSplitEqual[0], "");
				}
			}
		}
		return mapRequest;
	}
	// public static BasicHttpClientConnectionManager connManager = new
	// BasicHttpClientConnectionManager();

	private static CloseableHttpClient kit_getHttpClient(HttpUriRequest request) throws KeyManagementException, NoSuchProviderException, NoSuchAlgorithmException
	{
		CloseableHttpClient httpclient;
		if ("https".equals(request.getURI().getScheme()))
		{
			TrustManager[] tm = { ignoreCertificationTrustManger };
			SSLContext sslContext = SSLContext.getInstance("SSL", "SunJSSE");
			sslContext.init(null, tm, new SecureRandom());
			SSLConnectionSocketFactory sslsf = new SSLConnectionSocketFactory(sslContext, SSLConnectionSocketFactory.ALLOW_ALL_HOSTNAME_VERIFIER);
			httpclient = HttpClients.custom().setSSLSocketFactory(sslsf).setHostnameVerifier(ignoreHostnameVerifier).build();
		}
		else
		{
			httpclient = HttpClients.createDefault();
		}
		return httpclient;
	}

	private static String send(HttpUriRequest request) throws Exception
	{
		return send(request, "");
	}

	private static String send(HttpUriRequest request, String logMsg)
	{
		long curTime = System.currentTimeMillis();
		CloseableHttpClient httpclient = null;
		CloseableHttpResponse response = null;
		String result = null;
		String params = null;
		if (request instanceof HttpPost)
		{
			try
			{

				params = EntityUtils.toString(((HttpPost) request).getEntity(), "utf-8");
			}
			catch (Exception ignored)
			{

			}
		}
		try
		{
			httpclient = kit_getHttpClient(request);
		}
		catch (KeyManagementException e)
		{
			e.printStackTrace();
		}
		catch (NoSuchProviderException e)
		{
			e.printStackTrace();
		}
		catch (NoSuchAlgorithmException e)
		{
			e.printStackTrace();
		}
		try
		{
			response = httpclient.execute(request);
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}
		final HttpEntity entity = response.getEntity();
		try
		{
			result = EntityUtils.toString(entity, "utf-8");
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}
		try
		{
			EntityUtils.consume(entity);
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}
		if (!StringUtils.isBlank(params))
			System.out.println("http request url=[" + request.getURI() + "]" + printLogMsg(logMsg) + " params=[" + params + "] result=[" + result + "] " + (System.currentTimeMillis() - curTime));
		else
			System.out.println(("http request url=[" + request.getURI() + "]" + printLogMsg(logMsg) + " result=[" + result + "] " + (System.currentTimeMillis() - curTime)));

		return result;
	}

	private static String printLogMsg(String logMsg)
	{
		if (StringUtils.isBlank(logMsg))
		{
			return "";
		}
		return " ext[" + logMsg + "]";
	}

	private static void kit_resetConfigTimeout(HttpRequestBase requestBase, int second)
	{
		if (second > 0)
		{
			RequestConfig.Builder confBuilder = RequestConfig.custom();
			confBuilder.setSocketTimeout(second * 1000).setConnectTimeout(second * 1000);
			requestBase.setConfig(confBuilder.build());
		}
	}

	public static String httpMOLPWPost(String url, List<NameValuePair> nvps) throws Exception
	{
		String result = null;
		HttpPost httpPost = new HttpPost(url);
		kit_resetConfigTimeout(httpPost, DEFAULT_TIMEOUT);
		httpPost.setEntity(new UrlEncodedFormEntity(nvps, HTTP.UTF_8));
		httpPost.setHeader("Content-Type", "application/x-www-form-urlencoded;charset=utf-8");
		result = send(httpPost);
		//log.info(url + "-->response:" + result);
		return result;
	}

	private static String httpPost(String url, List<NameValuePair> nvps, int timeout) throws Exception
	{
		return httpPost(url, nvps, timeout, "");
	}

	private static String httpPost(String url, List<NameValuePair> nvps, int timeout, String logMsg) throws Exception
	{
		HttpPost httpPost = new HttpPost(url);
		kit_resetConfigTimeout(httpPost, timeout);
		httpPost.setEntity(new UrlEncodedFormEntity(nvps, HTTP.UTF_8));
		return send(httpPost, logMsg);
	}

	public static String httpPost(String url) throws Exception
	{
		return httpPost(url, "", DEFAULT_TIMEOUT);
	}

	public static String httpPostWithJSON(String url, Map<String, String> headers, Map<String, String> param) throws Exception
	{
		return httpPostWithJSON(url, headers, new JSONObject(param).toString());
	}

	public static String httpPostWithJSON(String url, Map<String, String> param) throws Exception
	{
		return httpPostWithJSON(url, null, param);
	}

	public static String httpPostWithJSON(String url, Map<String, String> headers, String json) throws Exception
	{
		String result;
		HttpPost httpPost = new HttpPost(url);
		kit_resetConfigTimeout(httpPost, DEFAULT_TIMEOUT);
		httpPost.setEntity(new StringEntity(json, "utf-8"));
		httpPost.setHeader("Content-Type", "application/json");
		if (headers != null)
		{
			for (Map.Entry<String, String> entry : headers.entrySet())
			{
				httpPost.addHeader(new BasicHeader(entry.getKey(), entry.getValue()));
			}
		}
		result = send(httpPost, "post->json格式");
		return result;
	}

	public static String httpPostWithJSON(String url, String json) throws Exception
	{
		return httpPostWithJSON(url, null, json);
	}

	public static String httpPost(String url, String content) throws Exception
	{
		return httpPost(url, content, DEFAULT_TIMEOUT);
	}

	public static String httpPost(String url, String content, int timeout) throws Exception
	{
		HttpPost httpPost = new HttpPost(url);
		kit_resetConfigTimeout(httpPost, timeout);
		httpPost.setEntity(new StringEntity(content, CHARSET));
		return send(httpPost);
	}

	private static String httpGet(String url, Map<String, String> headers, int timeout) throws Exception
	{
		HttpGet httpget = new HttpGet(url);
		if (headers != null)
		{
			for (Map.Entry<String, String> entry : headers.entrySet())
			{
				httpget.addHeader(new BasicHeader(entry.getKey(), entry.getValue()));
			}
		}
		kit_resetConfigTimeout(httpget, timeout);
		return send(httpget);
	}

	private static String httpGet(String url, int timeout) throws Exception
	{
		HttpGet httpget = new HttpGet(url);
		kit_resetConfigTimeout(httpget, timeout);
		return send(httpget);
	}

	/**
	 * @since ambertest1.0.0
	 */
	public static String sslPost(String url, List<NameValuePair> nvps, int timeout) throws Exception
	{
		String result = null;
		result = httpPost(url, nvps, timeout);
		//log.info(url + "-->response:" + result);
		return result;
	}

	public static String sslPost(String url, List<NameValuePair> nvps) throws Exception
	{
		return sslPost(url, nvps, DEFAULT_TIMEOUT);
	}

	public static String sslGet(String url) throws Exception
	{
		return sslGet(url, DEFAULT_TIMEOUT);
	}

	public static String sslGet(String url, int timeout) throws Exception
	{
		String result = null;
		result = httpGet(url, timeout);
		//log.info(url + "-->response:" + result);
		return result;
	}

	// 取hear
	public static Header[] HeaderSslGet(String url, int timeout) throws Exception
	{
		CloseableHttpClient httpclient = null;
		CloseableHttpResponse response = null;
		Header[] result = null;
		try
		{
			final HttpGet httpget = new HttpGet(url);
			kit_resetConfigTimeout(httpget, timeout);

			httpclient = kit_getHttpClient(httpget);
			response = httpclient.execute(httpget);
			result = response.getAllHeaders();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
		finally
		{
			if (response != null)
				response.close();
			if (httpclient != null)
				httpclient.close();
		}
		//log.info(url + "-->response:" + result);
		return result;
	}

	public static String get(String url, int timeout) throws Exception
	{
		String result = null;
		result = httpGet(url, timeout);
		//log.info(url + "-->response:" + result);
		return result;
	}

	public static String get(String s, Map<String, String> queryParas) throws Exception
	{
		return get(s, queryParas, null);
	}

	public static String get(String s, Map<String, String> queryParas, Map<String, String> headers) throws Exception
	{
		return httpGet(buildUrlWithQueryString(s, queryParas), headers, DEFAULT_TIMEOUT);
	}

	private static final String CHARSET = "UTF-8";

	/**
	 * Build queryString of the url
	 */
	public static String buildUrlWithQueryString(String url, Map<String, String> queryParas)
	{
		if (queryParas == null || queryParas.isEmpty())
		{
			return url;
		}

		StringBuilder sb = new StringBuilder(url);
		boolean isFirst;
		if (url.indexOf('?') == -1)
		{
			isFirst = true;
			sb.append('?');
		}
		else
		{
			isFirst = false;
		}

		for (Map.Entry<String, String> entry : queryParas.entrySet())
		{
			if (isFirst)
			{
				isFirst = false;
			}
			else
			{
				sb.append('&');
			}

			String key = entry.getKey();
			String value = entry.getValue();
			if (StringUtils.isNotBlank(value))
			{
				try {value = URLEncoder.encode(value, CHARSET);} catch (UnsupportedEncodingException e) {throw new RuntimeException(e);}
			}
			sb.append(key).append('=').append(value);
		}
		return sb.toString();
	}

	public static String get(String url) throws Exception
	{
		return get(url, DEFAULT_TIMEOUT);
	}

	public static String post(String url, Map<String, String> nvps, int timeout) throws Exception
	{
		return post(url, nvps, timeout, "");
	}

	public static String post(String url, Map<String, String> nvps, int timeout, String logMsg) throws Exception
	{
		List<NameValuePair> nvpss = new ArrayList<NameValuePair>();
		if (nvps != null)
		{
			for (Map.Entry<String, String> entry : nvps.entrySet())
			{
				nvpss.add(new BasicNameValuePair(entry.getKey(), entry.getValue() + ""));
			}
		}
		return httpPost(url, nvpss, timeout, logMsg);
	}

	public static String post(String url, Map<String, String> nvps) throws Exception
	{
		return post(url, nvps, "");
	}

	public static String post(String url, Map<String, String> nvps, String logMsg) throws Exception
	{
		return post(url, nvps, DEFAULT_TIMEOUT, logMsg);
	}

	public static String postMapObj(String url, Map<String, Object> nvps) throws Exception
	{
		List<NameValuePair> nvpss = new ArrayList<NameValuePair>();
		if (nvps != null)
		{
			for (Map.Entry<String, Object> entry : nvps.entrySet())
			{
				nvpss.add(new BasicNameValuePair(entry.getKey(), entry.getValue() + ""));
			}
		}
		return httpPost(url, nvpss, DEFAULT_TIMEOUT);
	}

	public static String post(String url, List<NameValuePair> nvps) throws Exception
	{
		//log.info(url + "-->response:" + result);
		return httpPost(url, nvps, DEFAULT_TIMEOUT);
	}

	public static String sslPostForMyCardBillingQuery(String url, String xmlParam, String soapAction) throws Exception
	{
		int timeout = 60;
		HttpPost httpPost = new HttpPost(url);
		kit_resetConfigTimeout(httpPost, timeout);
		httpPost.setHeader("SOAPAction", soapAction);
		httpPost.setHeader("Content-Type", "text/xml;charset=UTF-8");
		httpPost.setEntity(new StringEntity(xmlParam));
		//log.info(url + "-->response:" + result);
		return send(httpPost);
	}

	/** 将 192.168.1.1 转成整数 */
	public static Long inetAton(String add)
	{
		if (add != null && add.length() > 0)
		{
			long ip = 0, t = 0;
			int count = 0;
			char ch = 0;
			for (int i = 0, c = add.length(); i < c; i++)
			{
				ch = add.charAt(i);
				if (ch == '.')
				{
					count++;
					ip = ip * 256 + t;
					t = 0;
				}
				else if (ch < '0' || ch > '9')
				{
					break;
				}
				else
				{
					t = t * 10 + (ch - '0');
				}
			}
			if (ch >= '0' && ch <= '9')
			{
				count++;
				ip = ip * 256 + t;
			}
			if (count == 4 || count == 6)
			{
				return ip;
			}
		}
		return null;
	}

	public static String inetNtoa(long add)
	{
		return ((add & 0xff000000) >> 24) + "." + ((add & 0xff0000) >> 16) + "." + ((add & 0xff00) >> 8) + "." + ((add & 0xff));
	}

	public static String httpParamsToString(Map<String, String> params)
	{
		if (params == null)
			return "";
		Iterator<Map.Entry<String, String>> i = params.entrySet().iterator();

		StringBuilder sb = new StringBuilder();
		while (i.hasNext())
		{
			Map.Entry<String, String> e = i.next();
			String key = e.getKey();
			String value = e.getValue();
			sb.append(key);
			sb.append('=');
			sb.append(value);
			if (!i.hasNext())
				break;
			sb.append('&');
		}
		return sb.toString();
	}

}
