package com.herou;

import com.herou.lib.USDKOrderCallBack;
import org.json.JSONObject;
import org.junit.Test;

import java.util.HashMap;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotEquals;

/*
 * Created by huangguocai on 2021/11/3 15:44
 */
public class TestOrderCallBackSuccessApi {
    /**
     * 发货回调用例
     * @throws Exception
     */
    @Test
    public void testOrderCallBackSuccess() throws Exception {
        HashMap<String, Object> dataMap = new HashMap<>();
        dataMap.put("serverId", "s001");
        dataMap.put("roleLevel", "99");
        dataMap.put("vipLevel", "12");
        dataMap.put("totalCharge", "123.23");
        dataMap.put("getTime", "1631548801");
        dataMap.put("extraGet1", "123");
        dataMap.put("extraGet2", "23");
        dataMap.put("moneyType", "t1");
        dataMap.put("paymentMethod", 1);
        dataMap.put("eventType", "sdk_order_callback");
        dataMap.put("cUid", "U123456A");
        dataMap.put("cNam", "测试");
        dataMap.put("orderNo", "hu123456");
        dataMap.put("cpOrderId", "cp87654321");
        dataMap.put("goodsId", "good-1");
        dataMap.put("amount", "6.66");
        dataMap.put("unit", "CNY");
        dataMap.put("payTime", "1631548800");
        dataMap.put("roleName", "测试角色");
        dataMap.put("roleId", "rid0001");
        dataMap.put("serverName", "测试服001");

        USDKOrderCallBack usdkOrderCallBack = new USDKOrderCallBack("12345678", "12345678", USDKOrderCallBack.OrderCallBackUrlEnum.CN);

        JSONObject jsonObject = usdkOrderCallBack.orderCallback(dataMap);

        // {"msg":"Success","code":0}
        assertEquals("Success", jsonObject.get("msg"));
        assertEquals(0, jsonObject.get("code"));
    }

    /**
     * 发货回调缺少必要字段
     * @throws Exception
     */
    @Test
    public void testOrderCallBackKey() throws Exception {

        HashMap<String, Object> dataMap = new HashMap<>();
        dataMap.put("serverId", "s001");
        dataMap.put("roleLevel", "99");
        dataMap.put("vipLevel", "12");
        dataMap.put("totalCharge", "123.23");
        dataMap.put("getTime", "1631548801");
        dataMap.put("extraGet1", "123");
        dataMap.put("extraGet2", "23");
        dataMap.put("moneyType", "t1");
        dataMap.put("paymentMethod", 1);
        dataMap.put("eventType", "sdk_order_callback");
        dataMap.put("cUid", "U123456A");
        dataMap.put("cNam", "测试");
        dataMap.put("orderNo", "hu123456");
        dataMap.put("cpOrderId", "cp87654321");
        dataMap.put("goodsId", "good-1");
        dataMap.put("amount", "6.66");
        dataMap.put("unit", "CNY");
        dataMap.put("payTime", "1631548800");
        dataMap.put("roleName", "测试角色");
        // dataMap.put("roleId", "rid0001");
        dataMap.put("serverName", "测试服001");
        USDKOrderCallBack usdkOrderCallBack = new USDKOrderCallBack("12345678", "12345678", USDKOrderCallBack.OrderCallBackUrlEnum.CN);
        JSONObject jsonObject = usdkOrderCallBack.orderCallback(dataMap);

        assertEquals(-1, jsonObject.get("code"));
        // {"msg":"Success","code":0}
        assertEquals("roleId字段不存在", jsonObject.get("msg"));

        System.out.println(jsonObject);
    }


}
